// last modified: 10AUG1999: updated for gcc-2.95


#include "glib.h"
#include <stdio.h>

guint TFWhash (gconstpointer key);
gint TFWhashcmp (gconstpointer a, gconstpointer b);

int main (int argc, char **argv)
{
	int		i;
	char		*s;
	GHashTable	*h;

	h = g_hash_table_new (TFWhash, TFWhashcmp);
	for (i=0; i<20; i++)
		{
		s = new char[80];

		sprintf (s, "%d", i);
		g_hash_table_insert (h, s, s);
		printf ("+ %s\n", s);
		}

		
	s = new char[80];
	for (i=0; i<20; i++)
		{
		char 	*v;

		sprintf (s, "%d", i);
		v = (char *) g_hash_table_lookup (h, s);
		printf ("= %s\n", v);
		}
}


guint TFWhash (gconstpointer key)
{
        char    *s = (char *)key;
        int     i, v=0,
                l=strlen(s);

        for (i=0; i<l; i++)
                v = (64*v + s[i])%101;

        return (v);
}


gint TFWhashcmp (gconstpointer a, gconstpointer b)
{
        return (!strcmp((char *)a,(char *)b));
}

