// last modified: 10AUG1999: updated for gcc-2.95


#include <stdio.h>
#include <stdlib.h>

int hash_key_cmp (const void *_v1_, const void *_v2_);

int main (int argc, char **argv)
{
	char *t[] = { "xyz", "rst", "def", "abc" } ;

	qsort ((void *)t, 4, sizeof(char*), hash_key_cmp);
	for (int i=0; i<4; i++)
		printf ("%s\n", t[i]);
}


/*
 * hash_strcmp: compare 2 strings, used by qsort
 */
int hash_key_cmp (const void *_v1_, const void *_v2_)
{
	char    *v1=(char *)_v1_,
		*v2=(char *)_v2_;

        int rc = strcmp (v1, v2);
        if (rc < 0)
                return 1;
        else
        if (rc > 0)
                return -1;

        return 0;
}
